public with sharing class BRAssignmentCtrl {


    @AuraEnabled
    public static AssignmentRulesComponentWrapper getInputOutputDatasources(String scenarioId, String scenarioRuleInstanceId) {

        // first element is Base data set, 2nd is Assignment and third is output
        List<Data_Set_Rule_Map__c> inputOutputDataSet = new List<Data_Set_Rule_Map__c>{null,null,null};


        List<Data_Set_Rule_Map__c> inputOutputDataSourcesList = [ SELECT dataset_id__c,dataset_id__r.Name,ds_type__c,Id,table_name__c,File_Type__c,Table_Display_Name__c, scenario_rule_instance_id__c, scenario_rule_instance_id__r.Scenario_Id__r.Team_Instance__c,  scenario_rule_instance_id__r.Scenario_Id__r.Country__c FROM Data_Set_Rule_Map__c WHERE scenario_rule_instance_id__c =: scenarioRuleInstanceId ];


        Map<String,Data_Set_Rule_Map__c> mapInputDataSources = New Map<String,Data_Set_Rule_Map__c>();

        if(inputOutputDataSourcesList != null && inputOutputDataSourcesList.size() > 0 ){
            for(Data_Set_Rule_Map__c dsRuleMap : inputOutputDataSourcesList) {
                if(dsRuleMap.ds_type__c == 'I' && dsRuleMap.File_Type__c != null){
                    mapInputDataSources.put(dsRuleMap.File_Type__c ,dsRuleMap);
                }else if(dsRuleMap.ds_type__c == 'O'){
                    mapInputDataSources.put('Output' ,dsRuleMap);
                }
            }
        }

       
        AssignmentRulesComponentWrapper initResponse = new AssignmentRulesComponentWrapper();
        initResponse.dataSetAttributes = mapInputDataSources;

        Id basedataSetId, assignmentDatasetId;

        if ( mapInputDataSources.containsKey('Assignment') ){
             assignmentDatasetId = mapInputDataSources.get('Assignment').dataset_id__c;

             //GET PRODUCT DATA SOURCE ASSIGNMENT

            List<Data_Set_Rule_Map__c> productDataSource = [SELECT dataset_id__c, dataset_id__r.Name, dataset_id__r.SalesIQ_Internal__c,ds_type__c,Id,table_name__c,File_Type__c,Table_Display_Name__c, scenario_rule_instance_id__c FROM Data_Set_Rule_Map__c WHERE dataset_id__c =: assignmentDatasetId and ds_type__c = 'O'];
            List<Data_Set_Rule_Map__c> productDataSourceRM = [ SELECT dataset_id__c, dataset_id__r.Name, dataset_id__r.SalesIQ_Internal__c,ds_type__c,Id,table_name__c,File_Type__c,Table_Display_Name__c, scenario_rule_instance_id__c FROM Data_Set_Rule_Map__c WHERE scenario_rule_instance_id__c =: productDataSource[0].scenario_rule_instance_id__c and ds_type__c = 'I' ];


            mapInputDataSources.put('Product',productDataSourceRM[0]);



        }

        if ( mapInputDataSources.containsKey('Base')){
             basedataSetId = mapInputDataSources.get('Base').dataset_id__c;
        }

        if( assignmentDatasetId!= null && basedataSetId!= null ){
            initResponse.dataSetColumnAttributes = createColumnWrapper(basedataSetId,assignmentDatasetId);
        }

        boolean isAffiliationRule = mapInputDataSources.containsKey('Assignment') ? false :true;
        initResponse.listBusinessrules = getBusinessRules(scenarioId, scenarioRuleInstanceId, isAffiliationRule);

        //initResponse.levelOptions = getHierarchyLevel(scenarioId);

        AffiliationAttributes affiliationAttrs = new AffiliationAttributes();

        affiliationAttrs = getAffiliationAttributeOptions(scenarioId);

        initResponse.ruleLevelOptions = affiliationAttrs.ruleLevelOptions;
        initResponse.affilationLevels = affiliationAttrs.affilationLevels;


        //for(Data_Set_Rule_Map__c dsRuleMap : inputOutputDataSourcesList) {
        //    if(dsRuleMap.ds_type__c == 'I' && dsRuleMap.File_Type__c == CPGConstants.BASE_FILE_TYPE) {
        //        inputOutputDataSet[0] = dsRuleMap;
        //    } 
        //    else if(dsRuleMap.ds_type__c == 'I' && dsRuleMap.File_Type__c == CPGConstants.ASSIGNMENT_FILE_TYPE) {
        //        inputOutputDataSet[1] = dsRuleMap;
        //    } 
        //    else if(dsRuleMap.ds_type__c == 'O') {
        //        inputOutputDataSet[2] = dsRuleMap;
        //    }
        //}
        return initResponse;
    }

    @AuraEnabled
    public static list<BRMAssignmentFieldsWrapper> getColumns(String basedatasetId, String assignmentdatasetId) {
        List<BRMAssignmentFieldsWrapper> columns = createColumnWrapper(basedatasetId,assignmentdatasetId);
        return columns;         
    }

    @AuraEnabled
    public static List<String> getTeamInstance(String scenarioId) {
        List<String> result = new List<String>();
        List<Scenario__c > teamInst = [SELECT Id, Team_Instance__c, Team_Instance__r.Team__r.Country__c FROM Scenario__c where Id=:scenarioId];
        system.debug('Team Instance values'+teamInst[0].Team_Instance__c);
        result.add( String.valueof(teamInst[0].Team_Instance__c));
        result.add(String.valueof(teamInst[0].Team_Instance__r.Team__r.Country__c));
        return result;         
    }

    @AuraEnabled
    public static List<String> getformatedDates(List<String> datesVal) {

          system.debug('datesVal'+datesVal + datesVal.size());
         List<String> formatteddates = new List<String>();
         for(Integer ctr=0; ctr < datesVal.size();ctr++){
           system.debug('datesVal inside loop'+datesVal[ctr]);

           String originalDate = datesVal[ctr].split(' ')[0];
           system.debug('split check'+originalDate.split('-'));
           String day = originalDate.split('-')[2];
           String month = originalDate.split('-')[1];
           String year = originalDate.split('-')[0];    
           String originalTime = datesVal[ctr].split(' ')[1];
           String resultantDate = year + '-' + month + '-' + day + ' ' + originalTime;
           System.debug('resultantDate ' + resultantDate);
           Datetime st = Datetime.valueOf(resultantDate); 
           system.debug('ST'+st);
           system.debug('formatteddates'+st.format());
           formatteddates.add(st.format());

         }
     return formatteddates;

    }

    @AuraEnabled
    public static BRMRuleInfoWrapper getProductOptions(String internalDataSetId, String scenarioId, Boolean updateruleflag) {
        
        List<Data_Set_Column_Detail__c> allColumns = [SELECT dataset_id__r.Data_Set_Object_Name__c, Source_Column__c, dataset_id__r.Base_Data_Set__c, dataset_Id__c,Id,Key_Column__c, Key_Display_Column__c, tb_col_nm__c FROM Data_Set_Column_Detail__c WHERE dataset_id__c =: internalDataSetId and Source_Column__c != NULL];

        List<String> columnsList = new List<String>();
        String keyColumn, keyDisplayColumn;
        String keyColumnDb, keyDisplayColumnDb;
        for(Data_Set_Column_Detail__c ds : allColumns) {
            columnsList.add(ds.Source_Column__c);
            
            if(ds.Key_Column__c) {
                keyColumn = ds.Source_Column__c;
                keyColumnDb = ds.tb_col_nm__c;
            }

            if(ds.Key_Display_Column__c) {
                keyDisplayColumn = ds.Source_Column__c;
                keyDisplayColumnDb = ds.tb_col_nm__c;
            }
        }

        List<Scenario_Data_Object_Map__c> productDataMap = [select Id, Filter_Expression_Source__c from Scenario_Data_Object_Map__c where Scenario__c =: scenarioId and Data_Set__c =: allColumns[0].dataset_id__r.Base_Data_Set__c];

        Map<String, String> productOptions = new Map<String, String>();

        String dataQuery = 'select ' + String.join(columnsList, ',') + ' from ' + allColumns[0].dataset_id__r.Data_Set_Object_Name__c ;

        if(productDataMap[0] != null && productDataMap[0].Filter_Expression_Source__c!= null){
           /* + ' where ' + productDataMap[0].Filter_Expression_Source__c ; */
           dataQuery += ' where ' + productDataMap[0].Filter_Expression_Source__c ;
        }
        
        
        // fix for SIQ-3154  
        List<SObject> productData = Database.query(dataQuery);
        for(SObject pp : productData) {
            String displayColValue = '';
            if(keyDisplayColumn.contains('.')) {
                List<String> splitColumns = keyDisplayColumn.split('\\.');
                SObject tempObj ;
                for(integer i=0; i < splitColumns.size() -1 ; i++) {
                    if(i==0)
                        tempObj = pp.getSObject(splitColumns[i]);
                    else
                        tempObj = pp.getSObject(splitColumns[i]);
                }
                displayColValue = (String) tempObj.get(splitColumns[splitColumns.size()-1]);
            } else {
                displayColValue = (String) pp.get(keyDisplayColumn);
            }

            productOptions.put(String.valueOf(pp.get(keyColumn)), displayColValue);
        }      

        BRMRuleInfoWrapper wrapperObj = new BRMRuleInfoWrapper();
        wrapperObj.keycolumnvalues = productOptions;
        wrapperObj.keycolumnname = keyColumnDb;
        wrapperObj.keyDisplayColumnName = keyDisplayColumnDb;

        if(!updateruleflag) {
            wrapperObj.ruleLevel = 'Team';
        }
        return wrapperObj;
    }



    private static list<BRMAssignmentFieldsWrapper> createColumnWrapper(String basedatasetId, String assignmentdatasetId) {
    	List<String> dsList = new List<String>();

        dsList.add(basedatasetId);
        dsList.add(assignmentdatasetId);
    	List<Data_Set_Column_Detail__c> fieldstoincludelist = [SELECT dataset_id__r.Name,dataset_Id__c,column_id__c,datatype__c,Id,tb_col_nm__c,value_type__c,is_mandatory__c,ds_col_name__c,Table_Data_Type__c,variable_type__c,JoinStatus_Flag__c FROM Data_Set_Column_Detail__c WHERE dataset_id__c IN: dsList];
        List<BRMAssignmentFieldsWrapper> lstColumnData = new List<BRMAssignmentFieldsWrapper>();

        for(Data_Set_Column_Detail__c n : fieldstoincludelist)
        {
            BRMAssignmentFieldsWrapper columns=new BRMAssignmentFieldsWrapper();
            columns.Id = n.Id;
            columns.datasetId = n.dataset_id__c;
            columns.columnId = n.column_id__c;
            columns.tableColumnName=n.tb_col_nm__c;
            columns.datasourceName=n.dataset_id__r.Name;
            columns.colDatatype=n.datatype__c;
            columns.colValuetype=n.value_type__c;
            columns.datasourceColumnName=n.ds_col_name__c;
            columns.tableDataType=n.Table_Data_Type__c;
            columns.variableType=n.variable_type__c;
            columns.statusFlag = n.JoinStatus_Flag__c;
            lstColumnData.add(columns);
        }
        return lstColumnData;  
    }

    @AuraEnabled
    public static BRMRuleInfoWrapper assignedKeyColumn(String scenarioId,String scenarioRuleInstanceId,Boolean updateruleflag,Map<String,String> serviceresponseMap,String keycolumn,String keydisplaycolumn, String whereClause)
    {

        BRMRuleInfoWrapper wrapperObj = new BRMRuleInfoWrapper();
        //if(!updateruleflag) {
            
            ETL_Config__c config = CPGUtility.getETLConfigByName(CPGConstants.talend_Instance);
            // changes to send postgres cred to service
            system.debug('whereClause:: ' + whereClause);
            serviceresponseMap.put('where_clause' , EncodingUtil.urlEncode(whereClause, 'UTF-8'));
            serviceresponseMap.put('pg_username' , config.BR_PG_UserName__c);
            serviceresponseMap.put('pg_password' , config.BR_PG_Password__c);

            HttpResponse response = SalesiqUtility.getHTTPResponse(serviceresponseMap.get('finalURL'),serviceresponseMap,'POST',120000);
            String x = response.getBody();
           
            x = x.replace(' None', 'null');
            x = x.replace('\'', '"');

            system.debug('response: ' + x);
        	List<Map<String,String>> assignedValues = (List<Map<String,String>>)JSON.deserialize(x,List<Map<String,String>>.class);
        	
            /*
            List<Business_Rules__c> assignmentvalueslist = [SELECT Key_Column_Name__c,Key_Column_Value__c FROM Business_Rules__c WHERE ScenarioRuleInstanceDetails__c =: scenarioRuleInstanceId and Scenario__c =: scenarioId];
            
            Set<String> alreadyPresentProductKey = new Set<String>();
            for(Business_Rules__c busRules : assignmentvalueslist){
                alreadyPresentProductKey.add(busRules.Key_Column_Value__c);
            }*/

            Map<String, String> allAssignedToItems = new Map<String, String>();
            for(Map<String, String> eachRow : assignedValues) {
                String keyColumnValue, keyDisplayColumnValue;
                for(String colKey : eachRow.keySet()) {
                    if(keyColumn == colKey)
                        keyColumnValue = eachRow.get(colKey);

                    else if(keyDisplayColumn == colKey)
                        keyDisplayColumnValue = eachRow.get(colKey);
                }
                //if(!alreadyPresentProductKey.contains(keyColumnValue))
                    allAssignedToItems.put(keyColumnValue, keyDisplayColumnValue);
            }
            wrapperObj.keycolumnvalues = allAssignedToItems;

            if(!updateruleflag) {
                wrapperObj.ruleLevel = 'Team';
            }
        //}
        return wrapperObj;
    }

    @AuraEnabled
    public static void saveAssignmentRule(String BRMRuleInfoWrapperList,String scenarioId,String scenarioRuleInstanceId, String parsedQuery, String stagingQuery,String parsedJSONQuery,String firstdatasoureselectedId,String seconddatasoureselectedId,String assignmentFieldsWrapperList,String keydisplaycolumn,String keycolumn)
    {
     	List<Business_Rules__c> finalbusinessrulelist = new List<Business_Rules__c>();
        List<Scenario_Rule_Instance_Details__c> componenttypeList = [SELECT Component_Type_Master__c FROM Scenario_Rule_Instance_Details__c where Id =: scenarioRuleInstanceId limit 1];
     	String componentTypeId = componenttypeList[0].Component_Type_Master__c;
     	List<Business_Rule_Type_Master__c> businessruletypeval = [SELECT Id,Name FROM Business_Rule_Type_Master__c WHERE Component_Type__c =: componentTypeId];
     	String businessruletypeid = businessruletypeval[0].Id;

        //QUERY COMMENTED WITHOUT WHERECLAUSE
     	//List<Business_Rules__c> busruleList = [SELECT  Business_Rule_Type_Master__c,Reason_Code__c,Execution_Sequence__c,Is_Derived__c, Name,ScenarioRuleInstanceDetails__c,Scenario__c,Description__c,Key_Column_Name__c,Key_Column_Value__c,Key_Display_Column_Value__c FROM Business_Rules__c];

     	BRMRuleInfoWrapper wrapper = (BRMRuleInfoWrapper)JSON.deserialize(BRMRuleInfoWrapperList,BRMRuleInfoWrapper.class);
 		Business_Rules__c obj = new Business_Rules__c();

 		obj.Name = wrapper.ruleName;
 		obj.Description__c = wrapper.ruledescription; 	
        obj.Key_Column_Value__c = wrapper.ruleValue;
        obj.Reason_Code__c = wrapper.reasonCode;
        obj.Key_Column_Name__c =  keycolumn;
        obj.Key_Display_Column_Value__c = wrapper.keycolumnvalues.get(wrapper.ruleValue);
 		obj.Business_Rule_Type_Master__c = businessruletypeid;
 		obj.Execution_Sequence__c = 1;
 		obj.Is_Derived__c = false;
 		obj.ScenarioRuleInstanceDetails__c = scenarioRuleInstanceId;
 		obj.Scenario__c = scenarioId;
        obj.Rule_Level__c = wrapper.ruleLevel;
        obj.Selected_Positions__c = wrapper.selectedPositions;
 		finalbusinessrulelist.add(obj);

     	if(finalbusinessrulelist.size() > 0){
     		insert finalbusinessrulelist;
     	}	
     	
     	String bruleId;
     	for(Integer i=0;i<finalbusinessrulelist.size();i++){
     		bruleId = finalbusinessrulelist[i].Id;
     	}

        List<BRMAssignmentFieldsWrapper> assignmentwrapper = (list<BRMAssignmentFieldsWrapper>)JSON.deserialize(assignmentFieldsWrapperList,list<BRMAssignmentFieldsWrapper>.class);
        List<BRJoinRuleSelectCondition__c> joinRuleSelectionList = new List<BRJoinRuleSelectCondition__c>();
        Map<String,String> datasetvsTableNameMap = new Map<String,String>();
        List<Data_Set_Rule_Map__c> datasetTableNameList = [SELECT dataset_id__c,table_name__c,ds_type__c FROM Data_Set_Rule_Map__c WHERE scenario_rule_instance_id__c =: scenarioRuleInstanceId ];

        String dsIdOutput;
        Data_Set_Column_Detail__c ruleIDVal; 
        Data_Set_Column_Detail__c ruleNameVal; 
        //List<Data_Set_Rule_Map__c> dsIdOutputList = new List<Data_Set_Rule_Map__c>(); 

        for(Integer i=0;i<datasetTableNameList.size();i++){
            if(datasetTableNameList[i].ds_type__c == 'O'){
                //system.debug('ds_type_values');
                //system.debug(datasetTableNameList);
                //dsIdOutputList.add(datasetTableNameList[i]);
                dsIdOutput = datasetTableNameList[i].dataset_id__c;

            }
        }
        

        List<Data_Set_Column_Detail__c> dscdList = [SELECT ds_col_name__c,Source_Column__c,tb_col_nm__c from Data_Set_Column_Detail__c where dataset_id__c =: dsIdOutput and Source_Column__c in ('rule_id', 'rule_name')];

        for(Integer y=0;y<dscdList.size();y++){

            if(dscdList[y].Source_Column__c == 'rule_id' ) {
                ruleIDVal = dscdList[y];
            } 
            if(dscdList[y].Source_Column__c == 'rule_name' ) {
                ruleNameVal = dscdList[y];
            }  

        }

        for(Data_Set_Rule_Map__c nobj : datasetTableNameList){
            datasetvsTableNameMap.put(nobj.dataset_id__c,nobj.table_name__c);
        }

        system.debug(' ::::: datasetvsTableNameMap :::::::');
        system.debug(datasetvsTableNameMap);

        Integer index = 1;
        for(BRMAssignmentFieldsWrapper fieldwrapobj : assignmentwrapper)
        {
            BRJoinRuleSelectCondition__c brJoinSelectObj = new BRJoinRuleSelectCondition__c();
            index++;
            brJoinSelectObj.Business_Rules__c = bruleId;
            brJoinSelectObj.Data_Set_Field__c = fieldwrapobj.Id;
            brJoinSelectObj.Data_Set__c = fieldwrapobj.datasetId;
            brJoinSelectObj.Scenario__c = scenarioId;
            brJoinSelectObj.StatusFlag__c = fieldwrapobj.statusFlag;
            brJoinSelectObj.exec_tbl_name__c = datasetvsTableNameMap.get(fieldwrapobj.datasetId);
            brJoinSelectObj.Sequence__c = index;

            joinRuleSelectionList.add(brJoinSelectObj);

        }
        insert joinRuleSelectionList;     
        String displayexpression = 'SELECT ';
        String executeexpression = 'SELECT ';
        String insertexecexpression = '';
        String joinexecuteexpression = '(SELECT ';

        List<BRJoinRuleSelectCondition__c> selectedColumnsList = [SELECT Base_Business_Rule__c,Business_Rules__c,Data_Set_Field__r.ds_col_name__c,
        Data_Set__c,exec_tbl_name__c,Id,Name,Scenario__c,Scenario__r.isUniversal__c,Sequence__c,StatusFlag__c,Data_Set_Field__r.tb_col_nm__c
        FROM BRJoinRuleSelectCondition__c  where Scenario__c =: scenarioId and StatusFlag__c = true and Business_Rules__c =: bruleId];

        Boolean isUniversal = false;

        for(Integer z=0;z<selectedColumnsList.size();z++){
           isUniversal = selectedColumnsList[z].Scenario__r.isUniversal__c;
            if(wrapper.ruleValue != null && wrapper.ruleValue != '') {
                executeexpression = executeexpression + datasetvsTableNameMap.get(selectedColumnsList[z].Data_Set__c) +'.'+selectedColumnsList[z].Data_Set_Field__r.tb_col_nm__c + ',';
                insertexecexpression = insertexecexpression + selectedColumnsList[z].Data_Set_Field__r.tb_col_nm__c + ',';
            } else {
                if(seconddatasoureselectedId != selectedColumnsList[z].Data_Set__c) {
                    executeexpression = executeexpression + datasetvsTableNameMap.get(selectedColumnsList[z].Data_Set__c) +'.'+selectedColumnsList[z].Data_Set_Field__r.tb_col_nm__c + ',';
                    insertexecexpression = insertexecexpression + selectedColumnsList[z].Data_Set_Field__r.tb_col_nm__c + ',';
                }
            }
        }

        executeexpression = executeexpression.removeEnd(',');
        insertexecexpression = insertexecexpression.removeEnd(',');

        

        if(wrapper.ruleValue != null && wrapper.ruleValue != '')
        {    
            List<BRJoinRuleSelectCondition__c> firstsourceColumnsList = [SELECT Base_Business_Rule__c,Business_Rules__c,Data_Set_Field__r.ds_col_name__c, Data_Set__c,exec_tbl_name__c,Id,Name,Scenario__c,Sequence__c,StatusFlag__c,Data_Set_Field__r.tb_col_nm__c FROM BRJoinRuleSelectCondition__c  where Scenario__c =: scenarioId and StatusFlag__c = true and Business_Rules__c =: bruleId and Data_Set__c =: firstdatasoureselectedId];

            for(Integer a=0;a<firstsourceColumnsList.size();a++){
          		joinexecuteexpression = joinexecuteexpression + firstsourceColumnsList[a].Data_Set_Field__r.tb_col_nm__c + ',';
            }

            String positon_source_coulmn = SalesIQGlobalConstants.NAME_SPACE + 'Position__c' ;
            List<Data_Set_Column_Detail__c> dataTypeList = [SELECT Table_Data_Type__c, tb_col_nm__c, dataset_id__c, Key_Column__c FROM Data_Set_Column_Detail__c WHERE 
            (dataset_id__c =: seconddatasoureselectedId AND Key_Column__c = true) OR (dataset_id__c =: seconddatasoureselectedId AND Source_Column__c =: positon_source_coulmn and Key_Column__c = false) OR (dataset_id__c =: firstdatasoureselectedId and Key_Column__c = true)];


            String keyColumnDataType, secondaryKeyBase, secondaryKeyAssignment;

            for(Data_Set_Column_Detail__c dscd : dataTypeList) {
                if(dscd.dataset_id__c == seconddatasoureselectedId && dscd.Key_Column__c == true)
                    keyColumnDataType = dscd.Table_Data_Type__c;

                else if (dscd.dataset_id__c == firstdatasoureselectedId && dscd.Key_Column__c == true)
                    secondaryKeyBase = dscd.tb_col_nm__c;

                else if(dscd.dataset_id__c == seconddatasoureselectedId && dscd.Key_Column__c == false)
                    secondaryKeyAssignment = dscd.tb_col_nm__c;
            }

            joinexecuteexpression = joinexecuteexpression.removeEnd(',');
            if(wrapper.stagingQuery != null && wrapper.stagingQuery != '')
            {
                if(keyColumnDataType == CPGConstants.DATATYPE_TEXT){
                    joinexecuteexpression = joinexecuteexpression+','+keyColumnDataType+'(\''+wrapper.ruleValue+ '\') as '+keycolumn+ ' FROM ' + datasetvsTableNameMap.get(firstdatasoureselectedId) + ' where ' + wrapper.stagingQuery+')' + ' as ' + datasetvsTableNameMap.get(firstdatasoureselectedId) + ' INNER JOIN ' + datasetvsTableNameMap.get(seconddatasoureselectedId) + ' ON ' + datasetvsTableNameMap.get(firstdatasoureselectedId) +'.'+keycolumn+ ' = '+datasetvsTableNameMap.get(seconddatasoureselectedId)+ '.' +keycolumn;
                }

                else{
                    joinexecuteexpression = joinexecuteexpression+','+keyColumnDataType+'('+wrapper.ruleValue+') as '+keycolumn+ ' FROM ' + datasetvsTableNameMap.get(firstdatasoureselectedId) + ' where ' + wrapper.stagingQuery+')' + ' as ' + datasetvsTableNameMap.get(firstdatasoureselectedId) + ' INNER JOIN ' + datasetvsTableNameMap.get(seconddatasoureselectedId) + ' ON ' + datasetvsTableNameMap.get(firstdatasoureselectedId) +'.'+keycolumn+ ' = '+datasetvsTableNameMap.get(seconddatasoureselectedId)+ '.' +keycolumn;
                }
               
            }
            else{
                if(keyColumnDataType == CPGConstants.DATATYPE_TEXT){
                    joinexecuteexpression = joinexecuteexpression+','+keyColumnDataType+'(\''+wrapper.ruleValue+ '\') as '+keycolumn+ ' FROM ' + datasetvsTableNameMap.get(firstdatasoureselectedId) +')' + ' as ' + datasetvsTableNameMap.get(firstdatasoureselectedId) + ' INNER JOIN ' + datasetvsTableNameMap.get(seconddatasoureselectedId) + ' ON ' + datasetvsTableNameMap.get(firstdatasoureselectedId) +'.'+keycolumn+ ' = '+datasetvsTableNameMap.get(seconddatasoureselectedId)+ '.' +keycolumn;
                }

                else{
                    joinexecuteexpression = joinexecuteexpression+','+keyColumnDataType+'('+wrapper.ruleValue+') as '+keycolumn+ ' FROM ' + datasetvsTableNameMap.get(firstdatasoureselectedId) +')' + ' as ' + datasetvsTableNameMap.get(firstdatasoureselectedId) + ' INNER JOIN ' + datasetvsTableNameMap.get(seconddatasoureselectedId) + ' ON ' + datasetvsTableNameMap.get(firstdatasoureselectedId) +'.'+keycolumn+ ' = '+datasetvsTableNameMap.get(seconddatasoureselectedId)+ '.' +keycolumn;
                }
               
            } 

            if(secondaryKeyAssignment != null && secondaryKeyBase != null)
                joinexecuteexpression += ' and ' + datasetvsTableNameMap.get(firstdatasoureselectedId) +'.'+secondaryKeyBase+ ' = '+datasetvsTableNameMap.get(seconddatasoureselectedId)+ '.' +secondaryKeyAssignment;
        }    
        else
        {
            if(wrapper.stagingQuery != null && wrapper.stagingQuery != '')
            {
                  joinexecuteexpression =  datasetvsTableNameMap.get(firstdatasoureselectedId) + ' WHERE ' + wrapper.stagingQuery;
            }
            else
            {
                joinexecuteexpression = datasetvsTableNameMap.get(firstdatasoureselectedId);
            }
            
        }
        List<BR_JoinRule__c> joinRuleList = new List<BR_JoinRule__c>();

        BR_JoinRule__c brjoinruleobj = new BR_JoinRule__c();        
        brjoinruleobj.Business_Rules__c = bruleId;
        brjoinruleobj.Join_Rule_Execute_Expression__c = joinexecuteexpression;
        brjoinruleobj.Scenario__c = scenarioId;
       
        if(!dscdList.isEmpty()){
            brjoinruleobj.Select_Execute_Expression__c = executeexpression+ ',' + '\'' + bruleId  + '\',\'' + wrapper.ruleName + '\'' ;
            brjoinruleobj.insert_exec_expr__c = insertexecexpression + ',' +ruleIDVal.tb_col_nm__c + ','+ ruleNameVal.tb_col_nm__c ;
        }else{
            brjoinruleobj.Select_Execute_Expression__c = executeexpression; 
            brjoinruleobj.insert_exec_expr__c = insertexecexpression;
        }
        
        brjoinruleobj.where_expression__c = wrapper.parsedJSONQuery;
        brjoinruleobj.where_display_expression__c = wrapper.parsedQuery;
        joinRuleList.add(brjoinruleobj);



        insert joinRuleList; 

        /*CUSTOMER BLOCKING JOIN TO HAVE ADDITIONAL COLUMNS IN EXPRESSSION*/
        if(isUniversal){
            List<BR_JoinRule__c> br = [select id, Select_Execute_Expression__c,insert_exec_expr__c, Rule_Reason__c, Rule_Name__c from BR_JoinRule__c where id =:joinRuleList[0].id AND Scenario__c = :scenarioId];
            BR_JoinRule__c updatedBRJObj = new BR_JoinRule__c();
                string reasonCode = ( br[0].Rule_Reason__c != null ) ? br[0].Rule_Reason__c : '';
                updatedBRJObj.id = br[0].id;
                updatedBRJObj.insert_exec_expr__c = br[0].insert_exec_expr__c+',rulename,reasoncode,blocktype,status_block';
                updatedBRJObj.Select_Execute_Expression__c = br[0].Select_Execute_Expression__c+','+ '\''+br[0].Rule_Name__c+'\''+','+'\''+reasonCode+'\''+','+'\'Implicit\''+','+'\'Active\'';
            update updatedBRJObj;
        }
        
     	

    }
     
    @AuraEnabled
    public static void saveUpdatedAssignmentRules(String BRMRuleInfoWrapperList,String scenarioId,String scenarioRuleInstanceId, String parsedQuery, String stagingQuery,String parsedJSONQuery,String firstdatasoureselectedId,String seconddatasoureselectedId,String assignmentFieldsWrapperList,String keydisplaycolumn,String keycolumn)
    {
     	
        BRMRuleInfoWrapper wrapper = (BRMRuleInfoWrapper)JSON.deserialize(BRMRuleInfoWrapperList,BRMRuleInfoWrapper.class);

     	String businessruleId = wrapper.businessRuleId;

     	List<Business_Rules__c> finalUpdatedBusinessRulesList = new List<Business_Rules__c>();

     	List<Business_Rules__c> busrulelist = [SELECT Description__c,Id,Key_Column_Name__c,Key_Column_Value__c,Reason_Code__c,Key_Display_Column_Value__c,Name,
     	ScenarioRuleInstanceDetails__c,Scenario__c FROM Business_Rules__c
     	WHERE ScenarioRuleInstanceDetails__c =: scenarioRuleInstanceId and Scenario__c =: scenarioId and Id =: businessruleId];

     	if(busrulelist.size() > 0)
     	{
	     	for(Business_Rules__c nobj : busrulelist)
	     	{
	     		nobj.Name = wrapper.rulename;
	     		nobj.Description__c = wrapper.ruledescription;
	     		nobj.Key_Column_Name__c = wrapper.keycolumnname;
	     		nobj.Key_Column_Value__c = wrapper.ruleValue;
                nobj.Reason_Code__c = wrapper.reasonCode;
                //nobj.Key_Display_Column_Value__c = wrapper.keydisplaycolumnvalue;
                nobj.Key_Display_Column_Value__c = wrapper.keycolumnvalues.get(wrapper.ruleValue);
                nobj.Rule_Level__c = wrapper.ruleLevel;
                nobj.Selected_Positions__c = wrapper.selectedPositions;
	     		finalUpdatedBusinessRulesList.add(nobj);
	     	}
	     	update finalUpdatedBusinessRulesList;

            String bruleId;
            for(Integer i=0;i<finalUpdatedBusinessRulesList.size();i++){
                bruleId = finalUpdatedBusinessRulesList[i].Id;
            }

	     	String busruleid;
            String keycolumnvalue;
	     	String joinexecuteexpression = '(SELECT ';
           


	     	for(Integer i=0;i<finalUpdatedBusinessRulesList.size();i++){

	     		busruleid = finalUpdatedBusinessRulesList[i].Id;
	     	}

            for(Integer i=0;i<busrulelist.size();i++){
                keycolumnvalue = busrulelist[0].Key_Column_Value__c;
            }


	       List<BRJoinRuleSelectCondition__c> firstsourceColumnsList = [SELECT Base_Business_Rule__c,Business_Rules__c,Data_Set_Field__r.ds_col_name__c, Data_Set__c,exec_tbl_name__c,Id,Name,Scenario__c,Sequence__c,StatusFlag__c,Data_Set_Field__r.tb_col_nm__c FROM BRJoinRuleSelectCondition__c  where Scenario__c =: scenarioId and StatusFlag__c = true and Business_Rules__c =: busruleid and Data_Set__c =: firstdatasoureselectedId];

            Map<String,String> datasetvsTableNameMap = new Map<String,String>();

            List<Data_Set_Rule_Map__c> datasetTableNameList = [SELECT dataset_id__c,table_name__c,ds_type__c FROM Data_Set_Rule_Map__c WHERE scenario_rule_instance_id__c =: scenarioRuleInstanceId];

		    String dsIdOutput;
            Data_Set_Column_Detail__c ruleIDVal; 
            Data_Set_Column_Detail__c ruleNameVal; 
            //List<Data_Set_Rule_Map__c> dsIdOutputList = new List<Data_Set_Rule_Map__c>(); 

            for(Integer i=0;i<datasetTableNameList.size();i++){
                if(datasetTableNameList[i].ds_type__c == 'O'){
                    //system.debug('ds_type_values');
                //system.debug(datasetTableNameList);
                //dsIdOutputList.add(datasetTableNameList[i]);
                dsIdOutput = datasetTableNameList[i].dataset_id__c;

                }
            }
            
            List<Data_Set_Column_Detail__c> dscdList = [SELECT ds_col_name__c,Source_Column__c,tb_col_nm__c from Data_Set_Column_Detail__c where dataset_id__c =: dsIdOutput and Source_Column__c in ('rule_id', 'rule_name')];

            for(Integer y=0;y<dscdList.size();y++){

                if(dscdList[y].Source_Column__c == 'rule_id' ) {
                    ruleIDVal = dscdList[y];
                } 
                if(dscdList[y].Source_Column__c == 'rule_name' ) {
                    ruleNameVal = dscdList[y];
                }  

            }


            for(Data_Set_Rule_Map__c nobj : datasetTableNameList){

		      datasetvsTableNameMap.put(nobj.dataset_id__c,nobj.table_name__c);
		    }

             String executeexpression = 'SELECT ';
            String insertexecexpression = '';
        

            List<BRJoinRuleSelectCondition__c> selectedColumnsList = [SELECT Base_Business_Rule__c,Business_Rules__c,Data_Set_Field__r.ds_col_name__c,
            Data_Set__c,exec_tbl_name__c,Id,Name,Scenario__c,Scenario__r.isUniversal__c,Sequence__c,StatusFlag__c,Data_Set_Field__r.tb_col_nm__c
            FROM BRJoinRuleSelectCondition__c  where Scenario__c =: scenarioId and StatusFlag__c = true and Business_Rules__c =: bruleId];

            Boolean isUniversal = false;

            for(Integer z=0;z<selectedColumnsList.size();z++){
               isUniversal = selectedColumnsList[z].Scenario__r.isUniversal__c;
                if(wrapper.ruleValue != null && wrapper.ruleValue != '') {
                    executeexpression = executeexpression + datasetvsTableNameMap.get(selectedColumnsList[z].Data_Set__c) +'.'+selectedColumnsList[z].Data_Set_Field__r.tb_col_nm__c + ',';
                    insertexecexpression = insertexecexpression + selectedColumnsList[z].Data_Set_Field__r.tb_col_nm__c + ',';
                } else {
                    if(seconddatasoureselectedId != selectedColumnsList[z].Data_Set__c) {
                        executeexpression = executeexpression + datasetvsTableNameMap.get(selectedColumnsList[z].Data_Set__c) +'.'+selectedColumnsList[z].Data_Set_Field__r.tb_col_nm__c + ',';
                        insertexecexpression = insertexecexpression + selectedColumnsList[z].Data_Set_Field__r.tb_col_nm__c + ',';
                    }
                }
            }

            executeexpression = executeexpression.removeEnd(',');
            insertexecexpression = insertexecexpression.removeEnd(',');

            if(wrapper.ruleValue != null && wrapper.ruleValue != '')
            {            
                for(Integer a=0;a<firstsourceColumnsList.size();a++){
    	      	    joinexecuteexpression = joinexecuteexpression + firstsourceColumnsList[a].Data_Set_Field__r.tb_col_nm__c + ',';
                }
                    
                String positon_source_coulmn = SalesIQGlobalConstants.NAME_SPACE + 'Position__c' ;
                List<Data_Set_Column_Detail__c> dataTypeList = [SELECT Table_Data_Type__c, tb_col_nm__c, dataset_id__c, Key_Column__c FROM Data_Set_Column_Detail__c WHERE 
                (dataset_id__c =: seconddatasoureselectedId AND Key_Column__c = true) OR (dataset_id__c =: seconddatasoureselectedId AND Source_Column__c =: positon_source_coulmn and Key_Column__c = false) OR (dataset_id__c =: firstdatasoureselectedId and Key_Column__c = true)];


                String keyColumnDataType, secondaryKeyBase, secondaryKeyAssignment;

                for(Data_Set_Column_Detail__c dscd : dataTypeList) {
                    if(dscd.dataset_id__c == seconddatasoureselectedId && dscd.Key_Column__c == true)
                        keyColumnDataType = dscd.Table_Data_Type__c;

                    else if (dscd.dataset_id__c == firstdatasoureselectedId && dscd.Key_Column__c == true)
                        secondaryKeyBase = dscd.tb_col_nm__c;

                    else if(dscd.dataset_id__c == seconddatasoureselectedId && dscd.Key_Column__c == false)
                        secondaryKeyAssignment = dscd.tb_col_nm__c;
                }
                
                joinexecuteexpression = joinexecuteexpression.removeEnd(',');
                 
                if(wrapper.stagingQuery != null && wrapper.stagingQuery != '')
                {
                    if(keyColumnDataType == CPGConstants.DATATYPE_TEXT){

                        joinexecuteexpression = joinexecuteexpression+','+keyColumnDataType+'(\''+keycolumnvalue+ '\') as '+wrapper.keycolumnname+ ' FROM ' + datasetvsTableNameMap.get(firstdatasoureselectedId) + ' where ' + wrapper.stagingQuery+')' + ' as ' + datasetvsTableNameMap.get(firstdatasoureselectedId) + ' INNER JOIN ' + datasetvsTableNameMap.get(seconddatasoureselectedId) + ' ON ' + datasetvsTableNameMap.get(firstdatasoureselectedId) +'.'+wrapper.keycolumnname+ ' = '+datasetvsTableNameMap.get(seconddatasoureselectedId)+ '.' +wrapper.keycolumnname;
                    }

                    else{
                        joinexecuteexpression = joinexecuteexpression+','+keyColumnDataType+'('+keycolumnvalue+') as '+wrapper.keycolumnname+ ' FROM ' + datasetvsTableNameMap.get(firstdatasoureselectedId) + ' where ' + wrapper.stagingQuery+')' + ' as ' + datasetvsTableNameMap.get(firstdatasoureselectedId) + ' INNER JOIN ' + datasetvsTableNameMap.get(seconddatasoureselectedId) + ' ON ' + datasetvsTableNameMap.get(firstdatasoureselectedId) +'.'+wrapper.keycolumnname+ ' = '+datasetvsTableNameMap.get(seconddatasoureselectedId)+ '.' +wrapper.keycolumnname;
                    }
                }
                else
                {
                    if(keyColumnDataType == CPGConstants.DATATYPE_TEXT)
                    {                
                        joinexecuteexpression = joinexecuteexpression+','+keyColumnDataType+'(\''+keycolumnvalue+ '\') as '+wrapper.keycolumnname+ ' FROM ' + datasetvsTableNameMap.get(firstdatasoureselectedId) +')' + ' as ' + datasetvsTableNameMap.get(firstdatasoureselectedId) + ' INNER JOIN ' + datasetvsTableNameMap.get(seconddatasoureselectedId) + ' ON ' + datasetvsTableNameMap.get(firstdatasoureselectedId) +'.'+wrapper.keycolumnname+ ' = '+datasetvsTableNameMap.get(seconddatasoureselectedId)+ '.' +wrapper.keycolumnname;
                    }

                    else
                    {
                        joinexecuteexpression = joinexecuteexpression+','+keyColumnDataType+'('+keycolumnvalue+') as '+wrapper.keycolumnname+ ' FROM ' + datasetvsTableNameMap.get(firstdatasoureselectedId) +')' + ' as ' + datasetvsTableNameMap.get(firstdatasoureselectedId) + ' INNER JOIN ' + datasetvsTableNameMap.get(seconddatasoureselectedId) + ' ON ' + datasetvsTableNameMap.get(firstdatasoureselectedId) +'.'+wrapper.keycolumnname+ ' = '+datasetvsTableNameMap.get(seconddatasoureselectedId)+ '.' +wrapper.keycolumnname;
                    }
                }

                if(secondaryKeyAssignment != null && secondaryKeyBase != null)
                    joinexecuteexpression += ' and ' + datasetvsTableNameMap.get(firstdatasoureselectedId) +'.'+secondaryKeyBase+ ' = '+datasetvsTableNameMap.get(seconddatasoureselectedId)+ '.' +secondaryKeyAssignment;
                
            }    
            else
            {
                if(wrapper.stagingQuery != null && wrapper.stagingQuery != '')
                {
                  //  joinexecuteexpression = 'FROM ' + datasetvsTableNameMap.get(firstdatasoureselectedId) + ' WHERE ' + wrapper.stagingQuery;

                      joinexecuteexpression = datasetvsTableNameMap.get(firstdatasoureselectedId) + ' WHERE ' + wrapper.stagingQuery;
                }
                else
                {
                  //  joinexecuteexpression = 'FROM ' + datasetvsTableNameMap.get(firstdatasoureselectedId);

                       joinexecuteexpression = datasetvsTableNameMap.get(firstdatasoureselectedId);
                }
                
            }
     
	     	List<BR_JoinRule__c> joinruleList = [SELECT Business_Rules__c,Id,insert_exec_expr__c,Join_Rule_Execute_Expression__c,Name,
	     	Scenario__c,Select_Execute_Expression__c FROM BR_JoinRule__c WHERE Business_Rules__c =: busruleid];

               	
            for(Integer j=0;j<joinruleList.size();j++){
    	          
    	        joinruleList[j].Join_Rule_Execute_Expression__c = joinexecuteexpression;
                joinruleList[j].where_expression__c = parsedJSONQuery;
                joinruleList[j].where_display_expression__c = parsedQuery;
                if(!dscdList.isEmpty()){
                joinruleList[j].Select_Execute_Expression__c = executeexpression+ ',' + '\'' + bruleId  + '\',\'' + wrapper.ruleName + '\'' ;
                joinruleList[j].insert_exec_expr__c = insertexecexpression + ',' +ruleIDVal.tb_col_nm__c + ','+ ruleNameVal.tb_col_nm__c ;
                }else{
                    joinruleList[j].Select_Execute_Expression__c = executeexpression; 
                    joinruleList[j].insert_exec_expr__c = insertexecexpression;
                }
    	        
            }
            update joinruleList;
            
            /*CUSTOMER BLOCKING JOIN TO HAVE ADDITIONAL COLUMNS IN EXPRESSSION*/
            if(isUniversal){
                List<BR_JoinRule__c> br = [select id, Select_Execute_Expression__c,insert_exec_expr__c, Rule_Reason__c, Rule_Name__c from BR_JoinRule__c where id =:joinRuleList[0].id AND Scenario__c = :scenarioId];
                BR_JoinRule__c updatedBRJObj = new BR_JoinRule__c();
                    string reasonCode = ( br[0].Rule_Reason__c != null ) ? br[0].Rule_Reason__c : '';
                    updatedBRJObj.id = br[0].id;
                    updatedBRJObj.insert_exec_expr__c = br[0].insert_exec_expr__c+',rulename,reasoncode,blocktype,status_block';
                    updatedBRJObj.Select_Execute_Expression__c = br[0].Select_Execute_Expression__c+','+ '\''+br[0].Rule_Name__c+'\''+','+'\''+reasonCode+'\''+','+'\'Implicit\''+','+'\'Active\'';
                update updatedBRJObj;
            }
	     
     	}
    }

 @AuraEnabled
    public static void setProductEnable(String scenarioId, Boolean isProductEnabled){
        List<Scenario__c> updateScenarios = new List<Scenario__c>();
       // for( Scenario__c obj : [ Select id, Allow_Product_Level_Rules__c from Scenario__c where id = :scenarioId ] ){
            Scenario__c updatedObj = new Scenario__c(Id = scenarioId);
            updatedObj.Allow_Product_Level_Rules__c = isProductEnabled;
            updateScenarios.add(updatedObj);
       // }
       system.debug(updateScenarios);
        update updateScenarios;
    }

    @AuraEnabled
    public static List<BRMRuleInfoWrapper> getBusinessRules(String scenarioId,String scenarioRuleInstanceId, Boolean isAffiliationRule){

     	List<Business_Rules__c> existingbusinessrulelist = [SELECT  LastModifiedBy.Name,LastModifiedDate,BusinessRuleTemplateDetailsId__c,Business_Rule_Type_Master__c, Reason_Code__c,Description__c,Id,Key_Column_Name__c,Key_Column_Value__c,Key_Display_Column_Value__c,Name, ScenarioRuleInstanceDetails__c,Scenario__c, Scenario__r.Allow_Product_Level_Rules__c,Level__c,Geographic_Preference__c,Rule_Type__c, Rule_Level__c, Selected_Positions__c, (SELECT Business_Rules__c, where_display_expression__c,where_expression__c FROM BRJoinRules__r) FROM Business_Rules__c WHERE ScenarioRuleInstanceDetails__c =: scenarioRuleInstanceId and Scenario__c =: scenarioId];

     	List<BRMRuleInfoWrapper> updatedwrapperlist = new List<BRMRuleInfoWrapper>();
        BRMRuleInfoWrapper ruleobjDummy = new BRMRuleInfoWrapper();
        updatedwrapperlist.add(ruleobjDummy);
        String affheaderName = isAffiliationRule ? 'Criteria Name' : 'Rule Name';
        String affheaderLevel = isAffiliationRule ? 'Criteria Level' : 'Rule Level';
        //String affheaderCriteria = isAffiliationRule ? 'Criteria Level' : 'Rule Level';

        if(!existingbusinessrulelist.isEmpty()) {
            //ADD TABLE HEADERS 
            List<BRDataTableHeaders> tableHeaders = new List<BRDataTableHeaders>();
            tableHeaders.add(new BRDataTableHeaders('','Action'));
            tableHeaders.add(new BRDataTableHeaders('rulename',affheaderName));
            tableHeaders.add(new BRDataTableHeaders('reasonCode','Reason Code'));
            tableHeaders.add(new BRDataTableHeaders('keydisplaycolumnvalue','Product'));
            tableHeaders.add(new BRDataTableHeaders('ruleLevel',affheaderLevel));
            tableHeaders.add(new BRDataTableHeaders('selectedPositions','Selected Positions'));
            tableHeaders.add(new BRDataTableHeaders('parsedQuery','Rule Criteria'));

         	for(Business_Rules__c brobj : existingbusinessrulelist){

         		BRMRuleInfoWrapper ruleobj = new BRMRuleInfoWrapper();
         		ruleobj.rulename = brobj.Name;
         		ruleobj.ruledescription = brobj.Description__c;
         		ruleobj.ruleValue = brobj.Key_Column_Value__c;
                ruleobj.isProductEnabled = brobj.Scenario__r.Allow_Product_Level_Rules__c;
                ruleobj.ruleType = brobj.Rule_Type__c;
                ruleobj.geographicPreference = brobj.Geographic_Preference__c;
                ruleobj.level = brobj.Level__c;

                if(brobj.Rule_Level__c == null){
                    ruleobj.ruleLevel = 'Team';
                }else{
                    ruleobj.ruleLevel = brobj.Rule_Level__c;
                }
                if(brobj.Selected_Positions__c == null){
                    ruleobj.selectedPositions = '';

                }else{ 
                ruleobj.selectedPositions = brobj.Selected_Positions__c;
                }

                if(brobj.Reason_Code__c == null){
                    ruleobj.reasonCode = '-';
                }else{
                    ruleobj.reasonCode = brobj.Reason_Code__c;
                }
                
         		ruleobj.keycolumnname = brobj.Key_Column_Name__c;
         		ruleobj.businessRuleId = brobj.Id;
                if(brobj.Key_Display_Column_Value__c == ''|| brobj.Key_Display_Column_Value__c == null){
                    ruleobj.keyDisplayColumnValue = '-';
                }else{
                    ruleobj.keyDisplayColumnValue = brobj.Key_Display_Column_Value__c;
                }
                
                ruleobj.parsedQuery = brobj.BRJoinRules__r.isEmpty() ? '' : brobj.BRJoinRules__r[0].where_display_expression__c;
                ruleobj.parsedJSONQuery = brobj.BRJoinRules__r.isEmpty() ? '' : brobj.BRJoinRules__r[0].where_expression__c;

                ruleobj.keycolumnvalues = new Map<String, String>{brobj.Key_Column_Value__c => brobj.Key_Display_Column_Value__c};
                ruleobj.lastModifiedBy = brobj.LastModifiedBy.Name;
                ruleobj.lastModifiedDate = String.valueOf(brobj.LastModifiedDate);
                ruleobj.tableHeaders = tableHeaders;

         		updatedwrapperlist.add(ruleobj);
         	}
        } else {
            Scenario__c scenario = [select Allow_Product_Level_Rules__c from Scenario__c where Id =:scenarioId ];
            ruleobjDummy.isProductEnabled = scenario.Allow_Product_Level_Rules__c;
        }
     	return updatedwrapperlist;
    }

    

     @AuraEnabled
    public static List<BRDataWrapper> getPreviousData(String businessRuleId){

    List<BRDataWrapper> previousValuesList = new List<BRDataWrapper>();
    BRDataWrapper datawrapobj = new BRDataWrapper();

        List<Business_Rules__c> businessRuleDetailsList = [SELECT Description__c,Name,Rule_Level__c,Selected_Positions__c FROM Business_Rules__c WHERE Id =: businessRuleId];

        for(Business_Rules__c m : businessRuleDetailsList){

            datawrapobj.previousRuleName = m.Name;
            datawrapobj.previousRuleDescription = m.Description__c;
            datawrapobj.previousRuleLevel = m.Rule_Level__c;
            datawrapobj.previousSelectedPositions = m.Selected_Positions__c;

            previousValuesList.add(datawrapobj);
        }

        List<BR_JoinRule__c> joinRuleClauseList = [SELECT where_display_expression__c FROM BR_JoinRule__c WHERE Business_Rules__c =: businessRuleId];

        for(BR_JoinRule__c n : joinRuleClauseList){

            datawrapobj.previousWhereClause = n.where_display_expression__c;

            previousValuesList.add(datawrapobj);
        }

        return previousValuesList;

    }
     
    @AuraEnabled
    public static List<BRMRuleInfoWrapper> setRuleValues(String scenarioId,String scenarioRuleInstanceId,String rulename,String ruledescription,String rulevalue,String keycolumnname,String businessRuleId){

     	String stagingQuery;
        String parsedJSONQuery;

        List<BR_JoinRule__c> whereClauseList = [SELECT Business_Rules__c,where_display_expression__c,where_expression__c 
        FROM BR_JoinRule__c WHERE Business_Rules__c =: businessRuleId limit 1];

        for(Integer i=0;i<whereClauseList.size();i++){

            stagingQuery = whereClauseList[0].where_display_expression__c;
            parsedJSONQuery = whereClauseList[0].where_expression__c;
        }


        BRMRuleInfoWrapper wrapobj = new BRMRuleInfoWrapper();

 		wrapobj.rulename = rulename;
 		wrapobj.ruledescription = ruledescription;
 		wrapobj.ruleValue = rulevalue;
 		wrapobj.keycolumnname = keycolumnname;
 		wrapobj.businessRuleId = businessRuleId;
        wrapobj.stagingQuery = stagingQuery;
        wrapobj.parsedJSONQuery = parsedJSONQuery;

     	return new List<BRMRuleInfoWrapper>{wrapobj};
    }	

    @AuraEnabled
    public static Boolean ruleDelete(String businessRuleId) {

        List<BR_JoinRule__c> jruleList = [SELECT Business_Rules__c,Id,insert_exec_expr__c,Join_Rule_Execute_Expression__c,Name,Scenario__c,Select_Execute_Expression__c FROM BR_JoinRule__c WHERE Business_Rules__c =: businessRuleId];

            if(jruleList.size() > 0)
            {
                delete jruleList;

                List<Business_Rules__c> rulelisttobedeleted = [SELECT Description__c,Id, Key_Column_Name__c, Key_Column_Value__c,Name, ScenarioRuleInstanceDetails__c, Scenario__c FROM Business_Rules__c WHERE Id =: businessruleId];

                if(rulelisttobedeleted.size() > 0) {
                    delete rulelisttobedeleted;
                }
                return true;
            }

            else
            {
              return false;  
            }     
     	
    }

    @AuraEnabled
    public static List<String> getRuleLevel(String scenarioId) {
        String ns = SalesIQGlobalConstants.NAME_SPACE;
        list<String> ruleVals = SalesIQUtility.getpicklistvalues(ns+'Business_Rules__c',ns+'Rule_Level__c');
        Scenario__c currentScenario = [select Id, Business_Rule_Template__r.Allow_Position_Level_Rules__c from Scenario__c where Id =: scenarioId];
        
        if(!currentScenario.Business_Rule_Template__r.Allow_Position_Level_Rules__c) {
            for(Integer i=0; i<ruleVals.size(); i++) {
                if(ruleVals[i] == 'Position')
                    ruleVals.remove(i);
            }
        } 
        return ruleVals;
    }



    @AuraEnabled
    public static List<BRInstanceNameWrapper> getInstanceNameAndURL(String scenarioRuleInstanceId,String seconddatasoureselectedId,String scenarioId){

        List<String> lstInstanceNameAndURL = new List<String>();
        string brInstanceName =  CPGUtility.getBRMSConfigValues('BRAssignmentUrl');
        string brdbname = CPGUtility.getBRMSConfigValues('BRDatabaseName');

        String keycolumn;
        String keydisplaycolumn;
        String tablename;

        List<Data_Set_Column_Detail__c> keycolumnlist = [SELECT Key_Column__c, Key_Display_Column__c, ds_col_name__c,Id,tb_col_nm__c FROM Data_Set_Column_Detail__c WHERE dataset_id__c =: seconddatasoureselectedId AND (Key_Column__c = true OR Key_Display_Column__c = true)];

        for(Data_Set_Column_Detail__c columnDetail : keycolumnlist){
            if(columnDetail.Key_Column__c)
        	   keycolumn = columnDetail.tb_col_nm__c;

            if(columnDetail.Key_Display_Column__c)
        	   keydisplaycolumn = columnDetail.tb_col_nm__c;
        }

        List<Data_Set_Rule_Map__c> tablenamelist = [SELECT Id,Table_Display_Name__c,table_name__c,File_Type__c,dataset_id__r.is_internal__c  FROM Data_Set_Rule_Map__c WHERE scenario_rule_instance_id__r.Scenario_Id__c =: scenarioId AND ds_type__c = 'I' AND dataset_id__r.is_internal__c = false and file_type__c = 'Assignment'];

      	for(Integer j=0;j<tablenamelist.size();j++){
      		tablename = tablenamelist[j].table_name__c;
      	}

        List<Data_Set_Rule_Map__c> datasetIdList = [SELECT Id,Table_Display_Name__c,table_name__c,File_Type__c,dataset_id__r.is_internal__c,dataset_id__r.Base_Data_Set__c 
        FROM Data_Set_Rule_Map__c WHERE scenario_rule_instance_id__r.Scenario_Id__c =: scenarioId AND ds_type__c = 'I' AND 
        dataset_id__r.is_internal__c = false and file_type__c = 'Assignment'];

        String baseDatasetId = '';
        if(datasetIdList != null && datasetIdList.size() > 0)
            baseDatasetId = datasetIdList[0].dataset_id__r.Base_Data_Set__c;

        List<Scenario_Data_Object_Map__c> whereClauseList = [SELECT Filter_Expression_Destination__c FROM Scenario_Data_Object_Map__c 
        WHERE Scenario__c =: scenarioId and Data_Set__c =: baseDatasetId];
        String whereClause = '';
        if( whereClauseList != null && whereClauseList.size() > 0 ){
            whereClause = whereClauseList[0].Filter_Expression_Destination__c;
            if( whereClauseList[0].Filter_Expression_Destination__c == null)
            {
                whereClause = '';
            }
        }

        List<BRInstanceNameWrapper> columndata = new List<BRInstanceNameWrapper>();

        BRInstanceNameWrapper brtobj = new BRInstanceNameWrapper();
        brtobj.brassignmenturl = brInstanceName;
        brtobj.brdbname = brdbname;
        brtobj.keycolumn = keycolumn;
        brtobj.keydisplaycolumn = keydisplaycolumn;
        brtobj.tablename = tablename;
        brtobj.whereclause = whereClause;

        columndata.add(brtobj);
        return columndata;  
    }


    public class BRMRuleInfoWrapper {


        @AuraEnabled
        public String ruleType {get;set;}
        @AuraEnabled
        public String geographicPreference {get;set;}
        @AuraEnabled
        public String level {get;set;}
   
    	@AuraEnabled
        public String rulename {get;set;}
        @AuraEnabled
        public String ruledescription {get; set;}
        @AuraEnabled
        public String reasonCode {get; set;}      
        @AuraEnabled
        public Map<String,String> keycolumnvalues {get; set;}
        @AuraEnabled
        public String ruleValue {get; set;}

        @AuraEnabled
        public String ruleLevel {get; set;}
        @AuraEnabled
        public String selectedPositions {get; set;}

        @AuraEnabled
        public String keycolumnname {get; set;}
        @AuraEnabled
        public String keyDisplayColumnName {get; set;}
        @AuraEnabled
        public String keydisplaycolumnvalue {get; set;}
        @AuraEnabled
        public String businessRuleId {get; set;}
        @AuraEnabled
        public String stagingQuery {get; set;}
        @AuraEnabled
        public String parsedQuery {get; set;}
        @AuraEnabled
        public String parsedJSONQuery {get; set;}     
        @AuraEnabled
        public String lastModifiedBy {get; set;} 
        @AuraEnabled
        public String lastModifiedDate {get; set;}  
        @AuraEnabled
        public Boolean isProductEnabled {get; set;}  
        @AuraEnabled 
        public List<BRDataTableHeaders> tableHeaders{get;set;}
   

        public BRMRuleInfoWrapper() 
        {
        	ruleName = '';
        	ruledescription = '';
        	ruleValue = '';
        	keycolumnname = '';
            keydisplaycolumnvalue = '';
            reasonCode = '';
        	businessRuleId = '';
            stagingQuery = '';
            parsedJSONQuery = '';
            isProductEnabled = false;
            lastModifiedBy = '';
            lastModifiedDate = '';
            tableHeaders = new List<BRDataTableHeaders>();
            ruleType = '';
            geographicPreference = '';
            level = '';
        }
    }
    public class BRDataTableHeaders {
        //{"data":'',"title":'ACTION',defaultContent:''}
        @AuraEnabled
        public String data {get;set;}
        @AuraEnabled
        public String title {get;set;}
        @AuraEnabled
        public String defaultContent {get; set;} 
        public BRDataTableHeaders(String data,String title){
            this.data = data;
            this.title = title;
            this.defaultContent = '';
        }     
    }

    public class BRInstanceNameWrapper {
    	@AuraEnabled
        public String brassignmenturl {get;set;}
        @AuraEnabled
        public String brdbname {get;set;}
        @AuraEnabled
        public String keycolumn {get; set;}      
        @AuraEnabled
        public String keydisplaycolumn {get; set;}
        @AuraEnabled
        public String tablename {get; set;}
        @AuraEnabled
        public String whereclause {get; set;}       
    }

    public class BRMAssignmentFieldsWrapper {
        @AuraEnabled
        public String columnId {get;set;}
        @AuraEnabled
        public String tableColumnName {get; set;}      
        @AuraEnabled
        public String colDatatype {get; set;}        
        @AuraEnabled
        public String colValuetype {get; set;}
        @AuraEnabled
        public boolean statusFlag {get; set;}
        @AuraEnabled
        public String datasourceName {get; set;} 
        @AuraEnabled
        public String datasourceColumnName {get; set;}
        @AuraEnabled
        public String Id {get; set;}
        @AuraEnabled
        public String datasetId {get; set;}
        @AuraEnabled
        public String tableDataType {get; set;}
        @AuraEnabled
        public String variableType {get; set;}
    }

    public class BRDataWrapper{

        @AuraEnabled
        public String previousRuleName {get;set;}
        @AuraEnabled
        public String previousRuleDescription {get; set;}      
        @AuraEnabled
        public String previousWhereClause {get; set;}
        @AuraEnabled
        public String previousRuleLevel {get; set;}
        @AuraEnabled
        public String previousSelectedPositions {get; set;}
    }

    /*BR AFFILIATION CTLR CODE MERGED*/
    @AuraEnabled
    public static string getBusinessRuleId(String scenarioRuleInstanceId){
        list<Business_Rules__c> lstRules = [select id from Business_Rules__c where ScenarioRuleInstanceDetails__c =:scenarioRuleInstanceId];
        system.debug('lstRules--'+lstRules);
        if(lstRules.size()>0){
            return lstRules[0].Id;
            }else{
                return '';
            }

        }


        //@AuraEnabled
        //public static List<Data_Set_Rule_Map__c> getInputOutputDatasources(String scenarioRuleInstanceId, String moduleName) {

        //    List<Data_Set_Rule_Map__c> inputOutputDataSet = new Data_Set_Rule_Map__c[7];
        //    List<Data_Set_Rule_Map__c> inputOutputDataSourcesList = [SELECT dataset_id__c,dataset_id__r.Name,ds_type__c,Id,table_name__c,File_Type__c,Table_Display_Name__c FROM Data_Set_Rule_Map__c WHERE scenario_rule_instance_id__c =: scenarioRuleInstanceId];

        //    Map<String,Data_Set_Rule_Map__c> mapInputDataSources = New Map<String,Data_Set_Rule_Map__c>();

        //    for(Data_Set_Rule_Map__c dsRuleMap : inputOutputDataSourcesList) {
        //        if(dsRuleMap.ds_type__c == 'I' && dsRuleMap.File_Type__c != null){
        //            mapInputDataSources.put(dsRuleMap.File_Type__c ,dsRuleMap);
        //        }else if(dsRuleMap.ds_type__c == 'O'){
        //            mapInputDataSources.put('output_data_source' ,dsRuleMap);
        //        }
                
        //        if(dsRuleMap.ds_type__c == 'I' && dsRuleMap.File_Type__c == CPGConstants.BASE_FILE_TYPE) {
        //            mapInputDataSources.put('base_file_type',dsRuleMap);
        //        } 
        //        else if(dsRuleMap.ds_type__c == 'I' && dsRuleMap.File_Type__c == CPGConstants.CUST_TERR_FILE_TYPE) {
        //            mapInputDataSources.put('cust_terr',dsRuleMap);
        //        }
        //        else if(dsRuleMap.ds_type__c == 'I' && dsRuleMap.File_Type__c == CPGConstants.ZIP_TERR_FILE_TYPE) {
        //            mapInputDataSources.put('zip_terr',dsRuleMap);
        //        }
        //        else if(dsRuleMap.ds_type__c == 'I' && dsRuleMap.File_Type__c == CPGConstants.AFFILIATION_FILE_TYPE) {
        //            mapInputDataSources.put('aff_file_type',dsRuleMap);
        //        } 
        //        else if(dsRuleMap.ds_type__c == 'I' && dsRuleMap.File_Type__c == CPGConstants.BLOCK_FILE_TYPE) {
        //            mapInputDataSources.put('block_file_type',dsRuleMap);
        //        }
        //        else if(dsRuleMap.ds_type__c == 'I' && dsRuleMap.File_Type__c == CPGConstants.PRODUCT_FILE_TYPE) {
        //            mapInputDataSources.put('product_file_type',dsRuleMap);
        //        }
        //        else if(dsRuleMap.ds_type__c == 'O') {
        //            inputOutputDataSet[6] = dsRuleMap;
        //        }
        //    }
        //    return inputOutputDataSet;
        //}

        @AuraEnabled
        public static list<BRAffiliationWrapper> setAffiliationRulesWrapper(String ruleType, String geographicPreference,String level,List<String> parsedJsonQueryList,List<String> whereClauseList,List<String> stagingClauseList,List<String> sourceQueryList) {

            List<BRAffiliationWrapper> affiliationRulesDataList = new List<BRAffiliationWrapper>();


            BRAffiliationWrapper detailData = new BRAffiliationWrapper();

            detailData.ruleType = ruleType;
            detailData.geographicPreference = geographicPreference;
            detailData.level = level;
            detailData.parsedJsonQuery = parsedJsonQueryList;
            detailData.whereClauseQuery = whereClauseList;
            detailData.stagingClauseQuery = stagingClauseList;
            detailData.sourceQuery = sourceQueryList;

            affiliationRulesDataList.add(detailData);

            return affiliationRulesDataList;  
        }

        @AuraEnabled
        public static Boolean saveFinalValues (String BRAffiliationWrapperList,String scenarioRuleInstanceId,String scenarioId,Boolean alreadyExistingRuleFlag){



            System.debug('scenarioRuleInstanceId :: '+scenarioRuleInstanceId);
            System.debug('scenarioId :::: '+scenarioId);
            System.debug('BRAffiliationWrapperList :: ');
            System.debug(BRAffiliationWrapperList);
            System.debug('alreadyExistingRuleFlag :: ');
            System.debug(alreadyExistingRuleFlag);
            System.debug('scenarioRuleInstanceId :: '+scenarioRuleInstanceId);
            System.debug('scenarioId :::: '+scenarioId);
            List<BRAffiliationWrapper> wrapper = (List<BRAffiliationWrapper>)JSON.deserialize(BRAffiliationWrapperList,List<BRAffiliationWrapper>.class);

            if(alreadyExistingRuleFlag == false){

                System.debug(' alreadyExistingRuleFlag == false ');

                List<Scenario_Rule_Instance_Details__c> componenttypeList = [SELECT Component_Type_Master__c FROM Scenario_Rule_Instance_Details__c where Id =: scenarioRuleInstanceId limit 1];
                String componentTypeId = componenttypeList[0].Component_Type_Master__c;
                List<Business_Rule_Type_Master__c> businessruletypeval = [SELECT Id,Name FROM Business_Rule_Type_Master__c WHERE Component_Type__c =: componentTypeId];
                String businessruletypeid = businessruletypeval[0].Id;
                Business_Rules__c obj = new Business_Rules__c();

                System.debug('wrapper :::: '+wrapper);

                List<Business_Rules__c> finalbusinessrulelist = new List<Business_Rules__c>();

                obj.Business_Rule_Type_Master__c = businessruletypeid;
                obj.Execution_Sequence__c = 1;
                obj.Is_Derived__c = false;
                obj.ScenarioRuleInstanceDetails__c = scenarioRuleInstanceId;
                obj.Scenario__c = scenarioId;
                obj.Rule_Type__c = wrapper[0].ruleType;
                obj.Geographic_Preference__c = wrapper[0].geographicPreference;
                obj.Level__c = wrapper[0].level;
                
                finalbusinessrulelist.add(obj);

                if(finalbusinessrulelist.size() > 0){
                    insert finalbusinessrulelist;
                }   
                
                System.debug('finalbusinessrulelist :: '+finalbusinessrulelist);

                String bruleId;
                for(Integer i=0;i<finalbusinessrulelist.size();i++){
                    bruleId = finalbusinessrulelist[i].Id;
                }
                System.debug('bruleId ::: '+bruleId);
                
                List<BR_JoinRule__c> joinRuleList = new List<BR_JoinRule__c>();

                Integer sequence = 0;
                if(wrapper[0].ruleType == CPGConstants.AFFILIATION_RULE_TYPE_BOTTOM_UP)
                {

                    for(BRAffiliationWrapper brwrapobject : wrapper)
                    {
                        for(integer i=0;i<brwrapobject.whereClauseQuery.size();i++)
                        {
                            //GIVE CHILD 1 AND PARENT 2 IN EXECUTION SEQUENCE AND SO ON 
                            if((Math.mod(Integer.valueOf(i),2) == 0))
                            {
                                sequence ++;
                            }

                            BR_JoinRule__c brjoinruleobj = new BR_JoinRule__c();

                            brjoinruleobj.Scenario__c = scenarioId;
                            brjoinruleobj.Business_Rules__c = bruleId;
                            brjoinruleobj.where_expression__c = brwrapobject.stagingClauseQuery[i];
                            brjoinruleobj.where_display_expression__c = brwrapobject.whereClauseQuery[i];
                            brjoinruleobj.where_Json_Expression__c = brwrapobject.parsedJsonQuery[i];
                            brjoinruleobj.where_expression_source__c = brwrapobject.sourceQuery[i];
                            if((Math.mod(Integer.valueOf(i),2) == 0)){
                                brjoinruleobj.Affiliation_Hierarchy__c = 'Child';
                            }
                            else{
                                brjoinruleobj.Affiliation_Hierarchy__c = 'Parent';
                            }
                            //brjoinruleobj.Execution_Sequence__c = sequence;
                            brjoinruleobj.Execution_Sequence__c = Integer.valueOf(i)+1;

                            joinRuleList.add(brjoinruleobj);
                        }
                    }

                }

                else
                {

                    for(BRAffiliationWrapper brwrapobject : wrapper)
                    {
                        for(integer i=0;i<brwrapobject.whereClauseQuery.size();i++)
                        {

                            if((Math.mod(Integer.valueOf(i),2) == 0))
                            {
                                sequence ++;
                            }
                            BR_JoinRule__c brjoinruleobj = new BR_JoinRule__c();

                            brjoinruleobj.Scenario__c = scenarioId;  
                            brjoinruleobj.Business_Rules__c = bruleId;
                            brjoinruleobj.where_expression__c = brwrapobject.stagingClauseQuery[i];
                            brjoinruleobj.where_display_expression__c = brwrapobject.whereClauseQuery[i];
                            brjoinruleobj.where_Json_Expression__c = brwrapobject.parsedJsonQuery[i];
                            brjoinruleobj.where_expression_source__c = brwrapobject.sourceQuery[i];
                            if((Math.mod(Integer.valueOf(i),2) == 0)){
                                brjoinruleobj.Affiliation_Hierarchy__c = 'Parent';
                            }
                            else{
                                brjoinruleobj.Affiliation_Hierarchy__c = 'Child';
                            }
                            //brjoinruleobj.Execution_Sequence__c = sequence;
                            brjoinruleobj.Execution_Sequence__c = Integer.valueOf(i)+1;
                            joinRuleList.add(brjoinruleobj);
                        }
                    } 

                }

                System.debug('joinRuleList ::: '+joinRuleList);

                if(joinRuleList.size() > 0){
                    insert joinRuleList;
                    return true;
                }    
                else{
                    return false; 
                }
            }

            else{

             System.debug(' Update Case for Affiliation Rules '); /* Update Case for Affiliation Rules */

                List<Business_Rules__c> existingBusinessRuleId = [Select Id,Rule_Type__c,Geographic_Preference__c,Level__c FROM Business_Rules__c where Scenario__c =: scenarioId and ScenarioRuleInstanceDetails__c =: scenarioRuleInstanceId];

                for(Integer j=0;j<existingBusinessRuleId.size();j++){

                    existingBusinessRuleId[j].Rule_Type__c = wrapper[0].ruleType;
                    existingBusinessRuleId[j].Geographic_Preference__c = wrapper[0].geographicPreference;
                    existingBusinessRuleId[j].Level__c = wrapper[0].level;
                }

                if(existingBusinessRuleId.size() > 0){
                    update existingBusinessRuleId;
                }

                String businessRuleId = existingBusinessRuleId[0].Id;

                List<BR_JoinRule__c> existingListToBeDeleted = [SELECT Affiliation_Hierarchy__c,Business_Rules__c,Execution_Sequence__c,Id,Scenario__c
                ,where_display_expression__c,where_expression__c,where_Json_Expression__c FROM BR_JoinRule__c where Business_Rules__c =: businessRuleId];

                if(existingListToBeDeleted.size() > 0){
                    delete existingListToBeDeleted;
                }

                List<BR_JoinRule__c> joinRuleList = new List<BR_JoinRule__c>();
                Integer sequence = 0;
                if(wrapper[0].ruleType == CPGConstants.AFFILIATION_RULE_TYPE_BOTTOM_UP)
                {

                    for(BRAffiliationWrapper brwrapobject : wrapper)
                    {
                        for(integer i=0;i<brwrapobject.whereClauseQuery.size();i++)
                        {
                            if((Math.mod(Integer.valueOf(i),2) == 0))
                            {
                                sequence ++;
                            }
                            BR_JoinRule__c brjoinruleobj = new BR_JoinRule__c();

                            brjoinruleobj.Scenario__c = scenarioId;
                            brjoinruleobj.Business_Rules__c = businessRuleId;
                            brjoinruleobj.where_expression__c = brwrapobject.stagingClauseQuery[i];
                            brjoinruleobj.where_display_expression__c = brwrapobject.whereClauseQuery[i];
                            brjoinruleobj.where_Json_Expression__c = brwrapobject.parsedJsonQuery[i];
                            brjoinruleobj.where_expression_source__c = brwrapobject.sourceQuery[i];
                            if((Math.mod(Integer.valueOf(i),2) == 0)){
                                brjoinruleobj.Affiliation_Hierarchy__c = 'Child';
                            }
                            else{
                                brjoinruleobj.Affiliation_Hierarchy__c = 'Parent';
                            }
                            brjoinruleobj.Execution_Sequence__c = sequence;
                            joinRuleList.add(brjoinruleobj);
                        }
                    }

                }

                else
                {

                    for(BRAffiliationWrapper brwrapobject : wrapper)
                    {
                        for(integer i=0;i<brwrapobject.whereClauseQuery.size();i++)
                        {
                            if((Math.mod(Integer.valueOf(i),2) == 0))
                            {
                                sequence ++;
                            }
                            BR_JoinRule__c brjoinruleobj = new BR_JoinRule__c();

                            brjoinruleobj.Scenario__c = scenarioId;  
                            brjoinruleobj.Business_Rules__c = businessRuleId;
                            brjoinruleobj.where_expression__c = brwrapobject.stagingClauseQuery[i];
                            brjoinruleobj.where_display_expression__c = brwrapobject.whereClauseQuery[i];
                            brjoinruleobj.where_Json_Expression__c = brwrapobject.parsedJsonQuery[i];
                            brjoinruleobj.where_expression_source__c = brwrapobject.sourceQuery[i];
                            if((Math.mod(Integer.valueOf(i),2) == 0)){
                                brjoinruleobj.Affiliation_Hierarchy__c = 'Parent';
                            }
                            else{
                                brjoinruleobj.Affiliation_Hierarchy__c = 'Child';
                            }
                            brjoinruleobj.Execution_Sequence__c = sequence;
                            joinRuleList.add(brjoinruleobj);
                        }
                    } 

                }

                System.debug('joinRuleList ::: '+joinRuleList);

                if(joinRuleList.size() > 0){
                    insert joinRuleList;
                    return true;
                }    
                else{
                    return false; 
                }


            }




        }

        @AuraEnabled
        public static List<Map<String,String>> getHierarchyLevel(String scenarioId)
        {
            List<map<String,String>> levelsOptions = new List<map<String,String>>();

            Scenario__c mysc = [select Team_Instance__r.Affiliation_Network__r.Hierarchy_Level__c from Scenario__c where id=: scenarioId];
            if(mysc.Team_Instance__r.Affiliation_Network__r.Hierarchy_Level__c != null)
            {
                map<String,String> opmap = new map<String,String>(); 
                opmap.put('label','All');
                opmap.put('value','All');
                levelsOptions.add(opmap);

                for(Integer i=1;i <= Integer.valueOf(mysc.Team_Instance__r.Affiliation_Network__r.Hierarchy_Level__c);i++){
                        map<String,String> tempOpt = new map<String,String>(); 
                        tempOpt.put('label',''+String.valueOf(i));
                        tempOpt.put('value',''+String.valueOf(i));

                        levelsOptions.add(tempOpt);
                      // opts.push({label: ""+i, value: ""+i});
                }

                return levelsOptions;
                //return Integer.valueOf(mysc.Team_Instance__r.Affiliation_Network__r.Hierarchy_Level__c);
            }
            else
            {
                return null;
            }


        }

        @AuraEnabled
        public static List<BRAffiliationWrapper> callExistingBusinessRules (String scenarioId,String scenarioRuleInstanceId){

            List<Business_Rules__c> existingBusinessRulesList = [SELECT Id,Geographic_Preference__c,Rule_Type__c,Level__c FROM Business_Rules__c 
            WHERE ScenarioRuleInstanceDetails__c =: scenarioRuleInstanceId AND Scenario__c =: scenarioId limit 1];

            if(existingBusinessRulesList.size() > 0){
                String businessRuleId = existingBusinessRulesList[0].Id;
                String geographicPreference = existingBusinessRulesList[0].Geographic_Preference__c;
                String ruleType = existingBusinessRulesList[0].Rule_Type__c;
                String level = existingBusinessRulesList[0].Level__c;

                List<BRAffiliationWrapper> updatedAffWrapperList = new List<BRAffiliationWrapper>();

                List<BR_JoinRule__c> affiliationRulesBrUpdateList = [SELECT Affiliation_Hierarchy__c,Business_Rules__c,Execution_Sequence__c,Id,
                where_display_expression__c,where_expression__c,where_Json_Expression__c,where_expression_source__c FROM BR_JoinRule__c where Business_Rules__c =: businessRuleId];

                System.debug('affiliationRulesBrUpdateList:::: '+affiliationRulesBrUpdateList);
                System.debug('affiliationRulesBrUpdateList size:::: '+affiliationRulesBrUpdateList.size());

                List<String> tempList1 = new List<String>();
                List<String> tempList2 = new List<String>(); 
                List<String> tempList3 = new List<String>(); 
                List<String> tempList4 = new List<String>(); 
                List<Decimal> tempList5 = new List<Decimal>();
                List<String> tempList6 = new List<String>(); 

                List<BRAffiliationWrapper> updatedBRAffiliationWrapperList = new List<BRAffiliationWrapper>();

                for(BR_JoinRule__c obj : affiliationRulesBrUpdateList)
                {
                    tempList1.add(obj.where_Json_Expression__c);
                    tempList2.add(obj.where_display_expression__c);
                    tempList3.add(obj.where_expression__c);
                    tempList4.add(obj.Affiliation_Hierarchy__c);
                    tempList5.add(obj.Execution_Sequence__c);
                    tempList6.add(obj.where_expression_source__c);
                }

                BRAffiliationWrapper affWrapperObj = new BRAffiliationWrapper();

                affWrapperObj.ruleType = ruleType;
                affWrapperObj.geographicPreference = geographicPreference;
                affWrapperObj.level = level;
                affWrapperObj.parsedJsonQuery = tempList1;
                affWrapperObj.whereClauseQuery = tempList2;
                affWrapperObj.stagingClauseQuery = tempList3;
                affWrapperObj.affiliationHierarchy = tempList4;
                affWrapperObj.executionSequence = tempList5;
                affWrapperObj.sourceQuery = tempList6;

                updatedBRAffiliationWrapperList.add(affWrapperObj);

                System.debug('updatedBRAffiliationWrapperList :: '+updatedBRAffiliationWrapperList);

                return updatedBRAffiliationWrapperList;  

            }
            else{
                return null;
            }

        }

        @AuraEnabled
        public static void updateAffiliationRuleAttributes(String scenarioRuleInstanceId, Map<String,String> ruleAttributes)
        {

            system.debug(' ::::::scenarioRuleInstanceId ::::: ');
            system.debug(scenarioRuleInstanceId);

            system.debug(' ::::::ruleAttributes ::::: ');
            system.debug(ruleAttributes);
            
            List<Business_Rules__c> existingBusinessRulesList = [SELECT Id,Geographic_Preference__c,Rule_Type__c,Level__c FROM Business_Rules__c 
            WHERE ScenarioRuleInstanceDetails__c =: scenarioRuleInstanceId];

            Set<String> businessRuleIDSet = new Set<String>();
            for(Business_Rules__c brRule :existingBusinessRulesList){
                businessRuleIDSet.add(brRule.Id);
                brRule.Geographic_Preference__c = ruleAttributes.get('geographicPreference');
                brRule.Rule_Type__c = ruleAttributes.get('affiliationRuleType');
                brRule.Level__c = ruleAttributes.get('affiliationLevel');
            }
            //UPDATE JOIN QUERIES OF ALL BUSINESS RULES UPDATED
            updateBRJoinRulesOnAffiliationUpdate( businessRuleIDSet ,ruleAttributes.get('affiliationRuleType'));
            update existingBusinessRulesList;

        }


        /*METHOD TO UPDATE BR JOIN RULES*/
        private static void updateBRJoinRulesOnAffiliationUpdate( Set<String> businessRuleIDSet, String affiliationRuleType ){
            List<BR_JoinRule__c> exisitingJoinRule = [ SELECT id, Execution_Sequence__c, Affiliation_Hierarchy__c,Business_Rules__c from BR_JoinRule__c where Id IN :businessRuleIDSet ];
            if(exisitingJoinRule != null && exisitingJoinRule.size() > 0){
                for(BR_JoinRule__c brJoinObj :exisitingJoinRule)
                {
                    //TOP DOWN
                    if( affiliationRuleType == CPGConstants.AFFILIATION_RULE_TYPE_TOP_DOWN){
                        brJoinObj.Affiliation_Hierarchy__c = (brJoinObj.Execution_Sequence__c == 1 ) ? 'Parent' :  'Child';
   
                    }      
                    //BOTTOM UP
                    if( affiliationRuleType == CPGConstants.AFFILIATION_RULE_TYPE_BOTTOM_UP)
                    {
                        brJoinObj.Affiliation_Hierarchy__c = ( brJoinObj.Execution_Sequence__c == 1 ) ? 'Child' :  'Parent';
                    }
                }
                
            }
            update exisitingJoinRule;
        }


        public class BRAffiliationWrapper {

            @AuraEnabled
            public String ruleType {get;set;}
            @AuraEnabled
            public String geographicPreference {get;set;}
            @AuraEnabled
            public String level {get;set;}
            @AuraEnabled
            public List<String> parsedJsonQuery {get; set;}      
            @AuraEnabled
            public List<String> whereClauseQuery {get; set;}
            @AuraEnabled
            public List<String> stagingClauseQuery {get; set;}
            @AuraEnabled
            public List<String> sourceQuery {get; set;}
            @AuraEnabled
            public List<String> affiliationHierarchy {get; set;}
            @AuraEnabled
            public List<Decimal> executionSequence {get;set;}  

        }


        public class AssignmentRulesComponentWrapper  {
            @AuraEnabled
            public Map<String,Data_Set_Rule_Map__c> dataSetAttributes {get;set;}
            @AuraEnabled
            public list<BRMAssignmentFieldsWrapper> dataSetColumnAttributes {get;set;}
            @AuraEnabled
            public List<BRMRuleInfoWrapper> listBusinessrules {get;set;}
            @AuraEnabled
            public List<Map<String,String>> levelOptions {get;set;}
            @AuraEnabled
            public List<Map<String,String>> affilationLevels {get;set;}
            @AuraEnabled
            public List<Map<String,String>> ruleLevelOptions {get;set;}
        }

        @AuraEnabled
        public static AffiliationAttributes getAffiliationAttributeOptions(String scenarioId)
        {

            AffiliationAttributes attr = new AffiliationAttributes();
            try{
                
                List<Map<String,String>> ruleLevelOptions = new List<Map<String,String>>();
                List<Map<String,String>> hierachyLevelOptions = new List<Map<String,String>>();

                    Scenario__c currentScenario = [ select Team_Instance__r.Affiliation_Network__r.Hierarchy_Level__c, Business_Rule_Template__r.Allow_Position_Level_Rules__c from Scenario__c where Id =: scenarioId limit 1];

                    Map<String,String> hierarchyOption = new Map<String,String>();
                    hierarchyOption.put('label','All');hierarchyOption.put('value','All');
                    hierachyLevelOptions.add(hierarchyOption);
                    system.debug('INT H LEVEL');
                    system.debug(Integer.valueOf(currentScenario.Team_Instance__r.Affiliation_Network__r.Hierarchy_Level__c));
                    if( currentScenario.Team_Instance__r.Affiliation_Network__r.Hierarchy_Level__c != null ){
                        Integer i = 1;
                        for(i = 1; i <= Integer.valueOf(currentScenario.Team_Instance__r.Affiliation_Network__r.Hierarchy_Level__c) ; i++){
                            //hierachyLevelOptions.add( new SelectOption( String.valueOf(i),String.valueOf(i)) );
                            Map<String,String> hierarchyOptionVal = new Map<String,String>();
                            hierarchyOptionVal.put('label', String.valueOf(i) );hierarchyOptionVal.put('value', String.valueOf(i));
                            hierachyLevelOptions.add(hierarchyOptionVal);
                        }   
                    }

                    Map<String,String> ruleOption = new Map<String,String>();
                    ruleOption.put('label','Team');ruleOption.put('value','Team');
                    ruleLevelOptions.add(ruleOption);
                    if(currentScenario.Business_Rule_Template__r.Allow_Position_Level_Rules__c != null && currentScenario.Business_Rule_Template__r.Allow_Position_Level_Rules__c == true ){
                        //ruleLevelOptions.add(new SelectOption('Position','Position'));
                        Map<String,String> ruleOptionVal = new Map<String,String>();
                        ruleOptionVal.put('label','Position');ruleOptionVal.put('value','Position');
                        ruleLevelOptions.add(ruleOptionVal);
                    }

                    attr.affilationLevels = hierachyLevelOptions;
                    attr.ruleLevelOptions = ruleLevelOptions;

                    system.debug(' ==== attr =====');
                    system.debug(attr);

            }catch(Exception e){
                system.debug(e);
            }

            return attr;
        }


        public class AffiliationAttributes{
            @AuraEnabled
            public List<Map<String,String>> affilationLevels {get;set;}
            @AuraEnabled
            public List<Map<String,String>> ruleLevelOptions {get;set;}
        }
}